# Getting Started

Building a new [REPL](https://en.wikipedia.org/wiki/Read–eval–print_loop) or [Command Line Interface](https://en.wikipedia.org/wiki/Command-line_interface) application?

Already built an application that uses [cmd](https://docs.python.org/3/library/cmd.html) from the python standard library and want to add more functionality with very little work?

`cmd2` is a powerful python library for building command line applications. Start here to find out if this library is a good fit for your needs.

- [Installation Instructions](installation.md) - how to install `cmd2` and associated optional dependencies
- [First Application](../examples/first_app.md) - a sample application showing 8 key features of `cmd2`
- [Integrate cmd2 Into Your Project](integrating.md) - adding `cmd2` to your project
- [Alternatives](alternatives.md) - other python packages that might meet your needs
- [Resources](resources.md) - related links and other materials
